export declare type AtomInitialValue<T> = (T extends Function ? never : T) | (() => T);
export declare type AtomOptions = {};
export declare type AtomSubscription<T> = (value: T) => void;
export declare class Atom<T> {
    private _value;
    private _opts;
    private _subscriptions;
    constructor(initialValue: AtomInitialValue<T>, opts?: AtomOptions);
    get value(): T;
    set value(value: T);
    subscribe(subscription: AtomSubscription<T>): () => void;
}
/** Creates a new Atom with options */
export declare const createAtom: <T>(initialValue: AtomInitialValue<T>, opts?: AtomOptions) => Atom<T>;
