"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAtom = exports.Atom = void 0;
class Atom {
    _value;
    _opts;
    _subscriptions;
    constructor(initialValue, opts) {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        this._value = typeof initialValue === 'function' ? initialValue() : initialValue;
        this._opts = { ...opts };
        this._subscriptions = [];
        this.subscribe = this.subscribe.bind(this);
    }
    get value() {
        return this._value;
    }
    set value(value) {
        this._value = value;
        this._subscriptions.forEach((cb) => cb(value));
    }
    subscribe(subscription) {
        this._subscriptions.push(subscription);
        return () => {
            this._subscriptions = this._subscriptions.filter((cb) => cb !== subscription);
        };
    }
}
exports.Atom = Atom;
/** Creates a new Atom with options */
const createAtom = (initialValue, opts) => {
    return new Atom(initialValue, opts);
};
exports.createAtom = createAtom;
//# sourceMappingURL=Atom.js.map